%global dlrn_nvr networking-ovn-7.1.0.dev61-0.20200204065607.57ac389
%global dlrn 1
%define upstream_version 7.1.0.dev61
%{lua: posix.setenv("RHEL_ALLOW_PYTHON2_FOR_BUILD",1)}
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%else
%global pyver 2
%endif
%global pyver_bin python%{pyver}
%global pyver_sitelib %python%{pyver}_sitelib
%global pyver_install %py%{pyver}_install
%global pyver_build %py%{pyver}_build
# End of macros for py2/py3 compatibility
%global drv_vendor OVN
%global pkgname networking-ovn
%global srcname networking_ovn
%global docpath doc/build/html

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0

Name:           python-%{pkgname}
Version: 7.1.0
Release: 0.20200204065607.57ac389%{?dist}
Summary:        %{drv_vendor} OpenStack Neutron driver

License:        ASL 2.0
URL:            https://pypi.python.org/pypi/%{pkgname}
Source0: networking-ovn-7.1.0.dev61-0.20200204065607.57ac389.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=57ac38921efa6bbf0bc4a22950355256cc3ebe6d
Patch0001: 0001-Fix-for-getting-port-groups-while-using-OVS-up-to-2..patch

Source1:        networking-ovn-metadata-agent.service
#

BuildArch:      noarch

%description
OVN provides virtual networking for Open vSwitch and is a component of the
Open vSwitch project.

%package -n     python%{pyver}-%{pkgname}
Summary:        %{drv_vendor} OpenStack Neutron driver
%{?python_provide:%python_provide python%{pyver}-%{pkgname}}

BuildRequires:  git
BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-debtcollector
BuildRequires:  python%{pyver}-mock
BuildRequires:  openstack-macros

# This is required to generate the networking-ovn.ini configuration file
BuildRequires:  python%{pyver}-neutron

BuildRequires:  python%{pyver}-oslo-config
BuildRequires:  python%{pyver}-oslo-log
BuildRequires:  python%{pyver}-ovsdbapp
BuildRequires:  python%{pyver}-pbr

%if 0%{?with_doc}
BuildRequires:  python%{pyver}-openstackdocstheme
BuildRequires:  python%{pyver}-sphinx
BuildRequires:  python%{pyver}-sphinxcontrib-rsvgconverter
%endif

# python-openvswitch is not included in openstack-neutron-common.
# Its needed by networking-ovn.
Requires:       openstack-neutron-common >= 1:13.0.0
Requires:       python%{pyver}-babel >= 2.3.4
Requires:       python%{pyver}-futurist >= 1.2.0
Requires:       python%{pyver}-netaddr >= 0.7.18
Requires:       python%{pyver}-neutron-lib >= 1.28.0
Requires:       python%{pyver}-oslo-config >= 2:5.2.0
Requires:       python%{pyver}-octavia-lib >= 1.3.1
Requires:       python%{pyver}-openvswitch >= 2.8.0
Requires:       python%{pyver}-pbr >= 2.0.0
Requires:       python%{pyver}-six >= 1.10.0
Requires:       python%{pyver}-tenacity >= 4.4.0
Requires:       python%{pyver}-ovsdbapp >= 0.17.0
Requires:       python%{pyver}-pyOpenSSL >= 17.1.0
Requires:       python%{pyver}-requests >= 2.14.2
Requires:       python%{pyver}-sqlalchemy >= 1.2.0
Requires:       python%{pyver}-tooz >= 1.58.0

%description -n     python%{pyver}-%{pkgname}
OVN provides virtual networking for Open vSwitch and is a component of the
Open vSwitch project.

This package contains %{drv_vendor} networking driver which provides
integration between OpenStack Neutron and OVN.


%package -n     python%{pyver}-%{pkgname}-metadata-agent
Summary:        networking-ovn metadata agent
%{?python_provide:%python_provide python%{pyver}-%{pkgname}-metadata-agent}

BuildRequires:  systemd
Requires:       python%{pyver}-%{pkgname} = %{version}-%{release}
Requires:       openvswitch >= 2.8.0
Requires:       haproxy >= 1.5.0
%if 0%{?rhel} && 0%{?rhel} < 8
%{?systemd_requires}
%else
%{?systemd_ordering} # does not exist on EL7
%endif

%description -n     python%{pyver}-%{pkgname}-metadata-agent
OVN provides virtual networking for Open vSwitch and is a component of the
Open vSwitch project.

This package contains the agent that implements the metadata proxy so that VM's
can retrieve metadata from OpenStack Nova.

%package -n     python%{pyver}-%{pkgname}-migration-tool
Summary:        networking-ovn ML2/OVS to OVN migration tool
%{?python_provide:%python_provide python%{pyver}-%{pkgname}-migration-tool}

Requires:       python%{pyver}-%{pkgname} = %{version}-%{release}

%description -n     python%{pyver}-%{pkgname}-migration-tool
This package provides the necessary tools to update an existing ML2/OVS
OpenStack to OVN based backend.

%prep
%autosetup -n %{pkgname}-%{upstream_version} -S git

# Let's handle dependencies ourselves
%py_req_cleanup

# Kill egg-info in order to generate new SOURCES.txt
rm -rf {srcname}.egg-info


%build
export SKIP_PIP_INSTALL=1
%{pyver_build}

%if 0%{?with_doc}
sphinx-build-%{pyver} -b html doc/source %{docpath}
rm -rf %{docpath}/.{doctrees,buildinfo}
%endif

# Generate config file
PYTHONPATH=. oslo-config-generator-%{pyver} --namespace networking_ovn --output-file networking-ovn.ini
PYTHONPATH=. oslo-config-generator-%{pyver} --namespace networking_ovn.metadata.agent --output-file networking-ovn-metadata-agent.ini


%install
%{pyver_install}

# Remove unused files
rm -rf %{buildroot}%{pyver_sitelib}/bin
rm -rf %{buildroot}%{pyver_sitelib}/doc
rm -rf %{buildroot}%{pyver_sitelib}/tools


# Move config file to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
mv networking-ovn.ini %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
mv networking-ovn-metadata-agent.ini %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
chmod 640 %{buildroot}%{_sysconfdir}/neutron/plugins/*/*.ini

# Create configuration directories for all services that can be populated by users with custom *.conf files
mkdir -p %{buildroot}/%{_sysconfdir}/neutron/conf.d/networking-ovn-metadata-agent

# Install systemd units
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/networking-ovn-metadata-agent.service

%post -n python%{pyver}-%{pkgname}-metadata-agent
%systemd_post networking-ovn-metadata-agent.service


%preun -n python%{pyver}-%{pkgname}-metadata-agent
%systemd_preun networking-ovn-metadata-agent.service


%postun -n python%{pyver}-%{pkgname}-metadata-agent
%systemd_postun_with_restart networking-ovn-metadata-agent.service

%files -n python%{pyver}-%{pkgname}
%license LICENSE
%if 0%{?with_doc}
%doc %{docpath}
%endif
%{pyver_sitelib}/%{srcname}
%{pyver_sitelib}/%{srcname}-*.egg-info
%{_bindir}/neutron-ovn-db-sync-util
%dir %{_sysconfdir}/neutron/plugins/networking-ovn
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/plugins/networking-ovn/networking-ovn.ini

%files -n python%{pyver}-%{pkgname}-metadata-agent
%license LICENSE
%{_bindir}/networking-ovn-metadata-agent
%{_unitdir}/networking-ovn-metadata-agent.service
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/plugins/networking-ovn/networking-ovn-metadata-agent.ini
%dir %{_sysconfdir}/neutron/conf.d/networking-ovn-metadata-agent

%files -n python%{pyver}-%{pkgname}-migration-tool
%license LICENSE
%{_bindir}/networking-ovn-migration-mtu
%{_bindir}/ovn_migration.sh
%{_datadir}/ansible/networking-ovn-migration/playbooks/

%changelog
* Tue Feb 04 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Centralize traffic when LB and member has FIP

* Mon Feb 03 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Fix for getting port groups while using OVS up to 2.9

* Mon Feb 03 2020 Maciej Józefczyk <mjozefcz@redhat.com> 7.1.0-0.20200129045656.844540e
- Centralize traffic when LB and member has FIP (rhbz#1719291)

* Tue Jan 28 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Agent liveness - allow time to propagate checks" into stable/train
- Agent liveness - allow time to propagate checks

* Tue Jan 28 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "[OVN] Delete NAT entry first on any FIP update" into stable/train
- [OVN] Delete NAT entry first on any FIP update

* Mon Jan 27 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches

* Mon Jan 27 2020 Jakub Libosvar <libosvar@redhat.com> 7.1.0-0.20200124055736.75fe49a
- Agent liveness - allow time to propagate checks (rhbz#1793440)

* Fri Jan 24 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Don't fail if VIP already exist or has been deleted before" into stable/train
- Merge "Use 'container image prepare' in prepare-migration" into stable/train
- Don't fail if VIP already exist or has been deleted before
- Use 'container image prepare' in prepare-migration

* Thu Jan 23 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Don't send malformed status update to Octavia" into stable/train
- Don't send malformed status update to Octavia

* Wed Jan 22 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Fix py2 vs py3 dict keys comparison in functional test" into stable/train
- Fix py2 vs py3 dict keys comparison in functional test

* Wed Jan 22 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Exclude all device_ids that belong to Neutron DHCP Agent

* Fri Jan 17 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Cache OvnProviderHelper object in OvnProviderDriver" into stable/train
- Cache OvnProviderHelper object in OvnProviderDriver

* Thu Jan 16 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Don't fail in case subnet or Logical Switch not found" into stable/train
- Merge "Fix container images names in migration plugin" into stable/train
- Don't fail in case subnet or Logical Switch not found
- Fix container images names in migration plugin

* Wed Jan 15 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Add support for virtual port type" into stable/train
- Add support for virtual port type

* Wed Jan 15 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Add support for multiple L4 protocols withing same LB" into stable/train
- Merge "Enable InternalDNS related tests" into stable/train
- Merge "Change passed domain_name parameter value" into stable/train
- Add support for multiple L4 protocols withing same LB
- Enable InternalDNS related tests
- Change passed domain_name parameter value

* Tue Jan 14 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Set binding profile directly from OVNTrunkDriver (redo cont.)" into stable/train
- Set binding profile directly from OVNTrunkDriver (redo cont.)

* Tue Jan 14 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Add OVN Octavia CI jobs

* Tue Jan 07 2020 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "migration: Use ForceNeutronDriverUpdate when migrating" into stable/train
- Update master for stable/train
- migration: Use ForceNeutronDriverUpdate when migrating

* Fri Dec 20 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Only set "unknown" in LSP that makes sense

* Thu Dec 19 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Fix pep8 errors found by hacking 2.0.0

* Fri Dec 13 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- tox: Pass OVN and OVS source directories

* Mon Dec 09 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Switch release jobs to use OVS 2.12 in Train" into stable/train
- Switch release jobs to use OVS 2.12 in Train

* Fri Dec 06 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Update local.conf.sample to match stable/train" into stable/train
- Update local.conf.sample to match stable/train

* Thu Dec 05 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Fallback to default network_driver value if octavia not present" into stable/train
- Fallback to default network_driver value if octavia not present

* Wed Dec 04 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Fix agent extension support after hashring merge" into stable/train
- Fix agent extension support after hashring merge

* Wed Dec 04 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Added OSP16 & train to plugin spec." into stable/train
- Added OSP16 & train to plugin spec.

* Tue Dec 03 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Initialize TLS prior to retrieving OVSDB schema" into stable/train
- Initialize TLS prior to retrieving OVSDB schema

* Wed Nov 27 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Remove escape characters from container command

* Mon Nov 18 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "[metadata-agent] Fix issue with TLS/SSL connections" into stable/train
- [metadata-agent] Fix issue with TLS/SSL connections
- Add missing unittests to OVN provider driver

* Tue Nov 12 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Revert "Temporary jobs list change for stable/train"" into stable/train
- Revert "Temporary jobs list change for stable/train"

* Fri Oct 18 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches
- Merge "Disable ip_version checking while updating member without new ip" into stable/train
- Disable ip_version checking while updating member without new ip

* Thu Oct 17 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-1
- Update patches

* Wed Oct 16 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-0.2.0rc2
- Update patches
- Merge "Avoid port group creation race" into stable/train
- Avoid port group creation race

* Tue Oct 15 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-0.2.0rc2
- Update patches
- Do not lose router logical port upon subnet add on the external net

* Mon Oct 14 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-0.2.0rc2
- Update patches
- Set binding profile directly from OVNTrunkDriver (redo)

* Tue Oct 08 2019 OSP Prod Chain <dev-null@redhat.com> 7.0.0-0.1.0rc1
- Update patches

* Fri Oct 04 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

